diff --git a/src/corelib/itemmodels/qsortfilterproxymodel.cpp b/src/corelib/itemmodels/qsortfilterproxymodel.cpp
index 3a604c1..0853c98 100644
--- a/src/corelib/itemmodels/qsortfilterproxymodel.cpp
+++ b/src/corelib/itemmodels/qsortfilterproxymodel.cpp
@@ -139,7 +139,17 @@ class QSortFilterProxyModelPrivate : public QAbstractProxyModelPrivate
     Q_DECLARE_PUBLIC(QSortFilterProxyModel)
 
 public:
-    struct Mapping {
+    class Mapping {
+        Q_DISABLE_COPY(Mapping)
+    public:
+        Mapping()
+        {
+            qDebug() << __FUNCTION__ << this;
+        }
+        ~Mapping()
+        {
+            qDebug() << __FUNCTION__ << this;
+        }
         QVector<int> source_rows;
         QVector<int> source_columns;
         QVector<int> proxy_rows;
@@ -180,6 +190,7 @@ public:
         Q_ASSERT(proxy_index.isValid());
         Q_ASSERT(proxy_index.model() == q_func());
         const void *p = proxy_index.internalPointer();
+        qDebug() << __FUNCTION__ << "p=" << p;
         Q_ASSERT(p);
         QHash<QModelIndex, Mapping *>::const_iterator it =
             static_cast<const Mapping*>(p)->map_iter;
@@ -388,7 +399,7 @@ QModelIndex QSortFilterProxyModelPrivate::source_to_proxy(const QModelIndex &sou
         return QModelIndex(); // for now; we may want to be able to set a root index later
     if (source_index.model() != model) {
         qWarning() << "QSortFilterProxyModel: index from wrong model passed to mapFromSource";
-        Q_ASSERT(!"QSortFilterProxyModel: index from wrong model passed to mapFromSource");
+        Q_ASSERT_X(false, "bla", "QSortFilterProxyModel: index from wrong model passed to mapFromSource");
         return QModelIndex();
     }
     QModelIndex source_parent = source_index.parent();
@@ -1331,6 +1342,7 @@ void QSortFilterProxyModelPrivate::_q_sourceLayoutAboutToBeChanged(const QList<Q
 
 void QSortFilterProxyModelPrivate::_q_sourceLayoutChanged(const QList<QPersistentModelIndex> &sourceParents, QAbstractItemModel::LayoutChangeHint hint)
 {
+    qDebug() << __FUNCTION__ << "sourceParents=" << sourceParents.size();
     Q_Q(QSortFilterProxyModel);
 
     // Optimize: We only actually have to clear the mapping related to the contents of
@@ -1849,6 +1861,7 @@ void QSortFilterProxyModel::setSourceModel(QAbstractItemModel *sourceModel)
 */
 QModelIndex QSortFilterProxyModel::index(int row, int column, const QModelIndex &parent) const
 {
+    qDebug() << __FUNCTION__  << row << column;
     Q_D(const QSortFilterProxyModel);
     if (row < 0 || column < 0)
         return QModelIndex();
@@ -1866,6 +1879,7 @@ QModelIndex QSortFilterProxyModel::index(int row, int column, const QModelIndex
 */
 QModelIndex QSortFilterProxyModel::parent(const QModelIndex &child) const
 {
+    qDebug() << __FUNCTION__  << child;
     Q_D(const QSortFilterProxyModel);
     if (!d->indexValid(child))
         return QModelIndex();
@@ -1897,6 +1911,7 @@ QModelIndex QSortFilterProxyModel::sibling(int row, int column, const QModelInde
 */
 int QSortFilterProxyModel::rowCount(const QModelIndex &parent) const
 {
+    qDebug() << __FUNCTION__  ;
     Q_D(const QSortFilterProxyModel);
     QModelIndex source_parent = mapToSource(parent);
     if (parent.isValid() && !source_parent.isValid())
@@ -1910,6 +1925,7 @@ int QSortFilterProxyModel::rowCount(const QModelIndex &parent) const
 */
 int QSortFilterProxyModel::columnCount(const QModelIndex &parent) const
 {
+    qDebug() << __FUNCTION__  ;
     Q_D(const QSortFilterProxyModel);
     QModelIndex source_parent = mapToSource(parent);
     if (parent.isValid() && !source_parent.isValid())
@@ -1923,6 +1939,7 @@ int QSortFilterProxyModel::columnCount(const QModelIndex &parent) const
 */
 bool QSortFilterProxyModel::hasChildren(const QModelIndex &parent) const
 {
+    qDebug() << __FUNCTION__  ;
     Q_D(const QSortFilterProxyModel);
     QModelIndex source_parent = mapToSource(parent);
     if (parent.isValid() && !source_parent.isValid())
@@ -2714,8 +2731,12 @@ bool QSortFilterProxyModel::filterAcceptsColumn(int source_column, const QModelI
 */
 QModelIndex QSortFilterProxyModel::mapToSource(const QModelIndex &proxyIndex) const
 {
+
     Q_D(const QSortFilterProxyModel);
-    return d->proxy_to_source(proxyIndex);
+
+    QModelIndex r = d->proxy_to_source(proxyIndex);
+    qDebug() << __FUNCTION__ << r.row() << r.column() << r.data();
+    return r;
 }
 
 /*!
@@ -2726,6 +2747,7 @@ QModelIndex QSortFilterProxyModel::mapToSource(const QModelIndex &proxyIndex) co
 */
 QModelIndex QSortFilterProxyModel::mapFromSource(const QModelIndex &sourceIndex) const
 {
+    qDebug() << __FUNCTION__ ;
     Q_D(const QSortFilterProxyModel);
     return d->source_to_proxy(sourceIndex);
 }
diff --git a/src/widgets/dialogs/qfileinfogatherer.cpp b/src/widgets/dialogs/qfileinfogatherer.cpp
index df07de7..bda5af4 100644
--- a/src/widgets/dialogs/qfileinfogatherer.cpp
+++ b/src/widgets/dialogs/qfileinfogatherer.cpp
@@ -195,6 +195,7 @@ void QFileInfoGatherer::removePath(const QString &path)
 */
 void QFileInfoGatherer::list(const QString &directoryPath)
 {
+    qDebug() << __FUNCTION__ << directoryPath;
     fetchExtendedInformation(directoryPath, QStringList());
 }
 
diff --git a/src/widgets/dialogs/qfilesystemmodel.cpp b/src/widgets/dialogs/qfilesystemmodel.cpp
index 04238f2..30cbda2 100644
--- a/src/widgets/dialogs/qfilesystemmodel.cpp
+++ b/src/widgets/dialogs/qfilesystemmodel.cpp
@@ -610,6 +610,7 @@ bool QFileSystemModel::canFetchMore(const QModelIndex &parent) const
  */
 void QFileSystemModel::fetchMore(const QModelIndex &parent)
 {
+    qDebug() << __FUNCTION__ << parent.data();
     Q_D(QFileSystemModel);
     if (!d->setRootPath)
         return;
@@ -627,6 +628,7 @@ void QFileSystemModel::fetchMore(const QModelIndex &parent)
 */
 int QFileSystemModel::rowCount(const QModelIndex &parent) const
 {
+    qDebug() << __FUNCTION__ << parent.data();
     Q_D(const QFileSystemModel);
     if (parent.column() > 0)
         return 0;
@@ -643,6 +645,7 @@ int QFileSystemModel::rowCount(const QModelIndex &parent) const
 */
 int QFileSystemModel::columnCount(const QModelIndex &parent) const
 {
+    qDebug() << __FUNCTION__ << parent.data();
     return (parent.column() > 0) ? 0 : 4;
 }
 
@@ -670,6 +673,7 @@ QVariant QFileSystemModel::myComputer(int role) const
 */
 QVariant QFileSystemModel::data(const QModelIndex &index, int role) const
 {
+    qDebug() << __FUNCTION__ << index.row() << role;
     Q_D(const QFileSystemModel);
     if (!index.isValid() || index.model() != this)
         return QVariant();
@@ -972,8 +976,10 @@ Qt::ItemFlags QFileSystemModel::flags(const QModelIndex &index) const
 */
 void QFileSystemModelPrivate::_q_performDelayedSort()
 {
+    qDebug() << __FUNCTION__;
     Q_Q(QFileSystemModel);
     q->sort(sortColumn, sortOrder);
+    qDebug() << '<' << __FUNCTION__;
 }
 
 static inline QChar getNextChar(const QString &s, int location)
@@ -1174,6 +1180,7 @@ void QFileSystemModelPrivate::sortChildren(int column, const QModelIndex &parent
 */
 void QFileSystemModel::sort(int column, Qt::SortOrder order)
 {
+    qDebug() << __FUNCTION__ << "column=" <<column << order;
     Q_D(QFileSystemModel);
     if (d->sortOrder == order && d->sortColumn == column && !d->forceSort)
         return;
@@ -1202,6 +1209,7 @@ void QFileSystemModel::sort(int column, Qt::SortOrder order)
     }
     changePersistentIndexList(oldList, newList);
     emit layoutChanged();
+     qDebug() << '<' <<__FUNCTION__ ;
 }
 
 /*!
@@ -1386,6 +1394,7 @@ QFile::Permissions QFileSystemModel::permissions(const QModelIndex &index) const
   */
 QModelIndex QFileSystemModel::setRootPath(const QString &newPath)
 {
+    qDebug() << __FUNCTION__ << newPath;
     Q_D(QFileSystemModel);
 #ifdef Q_OS_WIN
 #ifdef Q_OS_WIN32
diff --git a/src/widgets/itemviews/qtreeview.cpp b/src/widgets/itemviews/qtreeview.cpp
index 188a503..94b35a7 100644
--- a/src/widgets/itemviews/qtreeview.cpp
+++ b/src/widgets/itemviews/qtreeview.cpp
@@ -3094,6 +3094,7 @@ void QTreeViewPrivate::expand(int item, bool emitSignal)
 
 void QTreeViewPrivate::insertViewItems(int pos, int count, const QTreeViewItem &viewItem)
 {
+    qDebug() << __FUNCTION__ << "pos=" << pos << "count=" << count;
     viewItems.insert(pos, count, viewItem);
     QTreeViewItem *items = viewItems.data();
     for (int i = pos + count; i < viewItems.count(); i++)
@@ -3103,6 +3104,7 @@ void QTreeViewPrivate::insertViewItems(int pos, int count, const QTreeViewItem &
 
 void QTreeViewPrivate::removeViewItems(int pos, int count)
 {
+    qDebug() << __FUNCTION__ << "pos=" << pos << "count=" << count;
     viewItems.remove(pos, count);
     QTreeViewItem *items = viewItems.data();
     for (int i = pos; i < viewItems.count(); i++)