=== modified file 'src/gui/text/qfontdatabase.cpp'
--- a/src/gui/text/qfontdatabase.cpp	2013-05-03 09:40:08 +0000
+++ b/src/gui/text/qfontdatabase.cpp	2015-08-04 10:40:09 +0000
@@ -1466,6 +1466,9 @@
 */
 bool QFontDatabase::isSmoothlyScalable(const QString &family, const QString &style) const
 {
+    if (QGuiApplicationPrivate::platformIntegration()->fontDatabase()->fontsAlwaysScalable())
+        return true;
+
     bool smoothScalable = false;
     QString familyName, foundryName;
     parseFontName(family, foundryName, familyName);

=== modified file 'src/platformsupport/fontdatabases/fontconfig/qfontconfigdatabase.cpp'
--- a/src/platformsupport/fontdatabases/fontconfig/qfontconfigdatabase.cpp	2013-05-03 09:40:08 +0000
+++ b/src/platformsupport/fontdatabases/fontconfig/qfontconfigdatabase.cpp	2015-08-04 11:02:35 +0000
@@ -813,6 +813,11 @@
     return QFont(resolved);
 }
 
+bool QFontconfigDatabase::fontsAlwaysScalable() const
+{
+    return true;
+}
+
 void QFontconfigDatabase::setupFontEngine(QFontEngineFT *engine, const QFontDef &fontDef) const
 {
     bool antialias = !(fontDef.styleStrategy & QFont::NoAntialias);
=== modified file 'src/platformsupport/fontdatabases/fontconfig/qfontconfigdatabase_p.h'
--- a/src/platformsupport/fontdatabases/fontconfig/qfontconfigdatabase_p.h	2013-05-03 09:40:08 +0000
+++ b/src/platformsupport/fontdatabases/fontconfig/qfontconfigdatabase_p.h	2015-08-04 11:03:32 +0000
@@ -57,6 +57,7 @@
     QStringList addApplicationFont(const QByteArray &fontData, const QString &fileName);
     QString resolveFontFamilyAlias(const QString &family) const;
     QFont defaultFont() const;
+    bool fontsAlwaysScalable() const;
 
 private:
     void setupFontEngine(QFontEngineFT *engine, const QFontDef &fontDef) const;