diff --git a/src/winextras/qwinjumplist.cpp b/src/winextras/qwinjumplist.cpp
index 9caebdc..6f1e519 100644
--- a/src/winextras/qwinjumplist.cpp
+++ b/src/winextras/qwinjumplist.cpp
@@ -115,7 +115,7 @@ void QWinJumpListPrivate::invalidate()
     Q_Q(QWinJumpList);
     if (!pDestList)
         return;
-
+qDebug() << __FUNCTION__ << "dirty=" << dirty;
     if (!dirty) {
         dirty = true;
         QMetaObject::invokeMethod(q, "_q_rebuild", Qt::QueuedConnection);
@@ -124,7 +124,9 @@ void QWinJumpListPrivate::invalidate()
 
 void QWinJumpListPrivate::_q_rebuild()
 {
+    qDebug() << __FUNCTION__ << ">dirty=" << dirty;
     if (beginList()) {
+        qDebug() << __FUNCTION__  << "beginList ok";
         if (recent && recent->isVisible())
             appendKnownCategory(KDC_RECENT);
         if (frequent && frequent->isVisible())
@@ -135,13 +137,15 @@ void QWinJumpListPrivate::_q_rebuild()
         }
         if (tasks && tasks->isVisible())
             appendTasks(tasks->items());
-        commitList();
+        bool x = commitList();
+        qDebug() << __FUNCTION__  << "commitList " <<x;
     }
     dirty = false;
 }
 
 void QWinJumpListPrivate::destroy()
 {
+    qDebug() << __FUNCTION__ ;
     delete recent;
     recent = 0;
     delete frequent;
@@ -191,8 +195,11 @@ void QWinJumpListPrivate::appendKnownCategory(KNOWNDESTCATEGORY category)
 void QWinJumpListPrivate::appendCustomCategory(QWinJumpListCategory *category)
 {
     IObjectCollection *collection = toComCollection(category->items());
+    qDebug() << __FUNCTION__ << this << "collection=" << collection;
     if (collection) {
         wchar_t *title = qt_qstringToNullTerminated(category->title());
+            qDebug() << __FUNCTION__ << category->title();
+
         HRESULT hresult = pDestList->AppendCategory(title, collection);
         if (FAILED(hresult))
             QWinJumpListPrivate::warning("AppendCategory", hresult);
@@ -203,6 +210,7 @@ void QWinJumpListPrivate::appendCustomCategory(QWinJumpListCategory *category)
 
 void QWinJumpListPrivate::appendTasks(const QList<QWinJumpListItem *> &items)
 {
+    qDebug() << __FUNCTION__ ;
     IObjectCollection *collection = toComCollection(items);
     if (collection) {
         HRESULT hresult = pDestList->AddUserTasks(collection);
@@ -215,6 +223,7 @@ void QWinJumpListPrivate::appendTasks(const QList<QWinJumpListItem *> &items)
 QList<QWinJumpListItem *> QWinJumpListPrivate::fromComCollection(IObjectArray *array)
 {
     QList<QWinJumpListItem *> list;
+    qDebug() << __FUNCTION__ ;
     UINT count = 0;
     array->GetCount(&count);
     for (UINT i = 0; i < count; ++i) {
@@ -240,6 +249,7 @@ QList<QWinJumpListItem *> QWinJumpListPrivate::fromComCollection(IObjectArray *a
         if (jumplistItem)
             list.append(jumplistItem);
     }
+    qDebug() << __FUNCTION__ << "rets " << list;
     return list;
 }
 
@@ -247,6 +257,7 @@ IObjectCollection *QWinJumpListPrivate::toComCollection(const QList<QWinJumpList
 {
     if (list.isEmpty())
         return 0;
+    qDebug() << __FUNCTION__ <<  list;
     IObjectCollection *collection = 0;
     HRESULT hresult = CoCreateInstance(qCLSID_EnumerableObjectCollection, 0, CLSCTX_INPROC_SERVER, qIID_IObjectCollection, reinterpret_cast<void **>(&collection));
     if (FAILED(hresult)) {
@@ -287,7 +298,7 @@ QWinJumpListItem *QWinJumpListPrivate::fromIShellLink(IShellLinkW *link)
 
     link->GetPath(buffer, buffersize-1, 0, 0);
     item->setFilePath(QDir::fromNativeSeparators(QString::fromWCharArray(buffer)));
-
+qDebug() << __FUNCTION__ << link << item;
     return item;
 }
 
@@ -298,6 +309,7 @@ QWinJumpListItem *QWinJumpListPrivate::fromIShellItem(IShellItem2 *shellitem)
     shellitem->GetDisplayName(SIGDN_FILESYSPATH, &strPtr);
     item->setFilePath(QDir::fromNativeSeparators(QString::fromWCharArray(strPtr)));
     CoTaskMemFree(strPtr);
+    qDebug() << __FUNCTION__ << shellitem << item;
     return item;
 }
 
@@ -370,6 +382,7 @@ IShellLinkW *QWinJumpListPrivate::toIShellLink(const QWinJumpListItem *item)
     PropVariantClear(&titlepv);
 
     delete[] buffer;
+    qDebug() << __FUNCTION__ << item << "rets" << link;
     return link;
 }
 
@@ -381,6 +394,7 @@ IShellItem2 *QWinJumpListPrivate::toIShellItem(const QWinJumpListItem *item)
         QScopedArrayPointer<wchar_t> buffer(qt_qstringToNullTerminated(item->filePath()));
         qtShell32Dll.sHCreateItemFromParsingName(buffer.data(), 0, qIID_IShellItem2, reinterpret_cast<void **>(&shellitem));
     }
+    qDebug() << __FUNCTION__ << item << "rets" << shellitem;
     return shellitem;
 }
 
@@ -465,10 +479,13 @@ void QWinJumpList::setIdentifier(const QString &identifier)
     id.replace(QLatin1Char(' '), QLatin1Char('_'));
     if (id.size() > 128)
         id.truncate(128);
+
     if (d->identifier != id) {
+        qDebug() << __FUNCTION__ << "new id" << id;
         d->identifier = id;
         d->invalidate();
     }
+    qDebug() << __FUNCTION__ << "<";
 }
 
 /*!
diff --git a/src/winextras/qwinjumplistcategory.cpp b/src/winextras/qwinjumplistcategory.cpp
index b49b6cd..1c917e3 100644
--- a/src/winextras/qwinjumplistcategory.cpp
+++ b/src/winextras/qwinjumplistcategory.cpp
@@ -79,6 +79,7 @@ QWinJumpListCategoryPrivate::QWinJumpListCategoryPrivate() :
 
 QWinJumpListCategory *QWinJumpListCategoryPrivate::create(QWinJumpListCategory::Type type, QWinJumpList *jumpList)
 {
+    qDebug()<< __FUNCTION__;
     QWinJumpListCategory *category = new QWinJumpListCategory;
     category->d_func()->type = type;
     category->d_func()->jumpList = jumpList;
@@ -89,25 +90,30 @@ QWinJumpListCategory *QWinJumpListCategoryPrivate::create(QWinJumpListCategory::
 
 void QWinJumpListCategoryPrivate::invalidate()
 {
+    qDebug()<< __FUNCTION__ << '>';
     if (jumpList)
         QWinJumpListPrivate::get(jumpList)->invalidate();
+    qDebug()<< __FUNCTION__ << '<';
 }
 
 void QWinJumpListCategoryPrivate::loadRecents()
 {
+    qDebug()<< __FUNCTION__<< '>';
     Q_ASSERT(jumpList);
     IApplicationDocumentLists *pDocList = 0;
     HRESULT hresult = CoCreateInstance(qCLSID_ApplicationDocumentLists, 0, CLSCTX_INPROC_SERVER, qIID_IApplicationDocumentLists, reinterpret_cast<void **>(&pDocList));
     if (SUCCEEDED(hresult)) {
         if (!jumpList->identifier().isEmpty()) {
-            wchar_t *id = qt_qstringToNullTerminated(jumpList->identifier());
+            wchar_t *id = qt_qstringToNullTerminated(jumpList->identifier());            
             hresult = pDocList->SetAppID(id);
+            qDebug() << __FUNCTION__ << "AppId=" << jumpList->identifier() << SUCCEEDED(hresult);
             delete[] id;
         }
         if (SUCCEEDED(hresult)) {
             IObjectArray *array = 0;
             hresult = pDocList->GetList(type == QWinJumpListCategory::Recent ? ADLT_RECENT : ADLT_FREQUENT,
                                         0, qIID_IObjectArray, reinterpret_cast<void **>(&array));
+            qDebug() << __FUNCTION__ << "gETlIST()" <<  SUCCEEDED(hresult);
             if (SUCCEEDED(hresult)) {
                 items = QWinJumpListPrivate::fromComCollection(array);
                 array->Release();
@@ -117,10 +123,12 @@ void QWinJumpListCategoryPrivate::loadRecents()
     }
     if (FAILED(hresult))
         QWinJumpListPrivate::warning("loadRecents", hresult);
+    qDebug()<< __FUNCTION__ << '<';
 }
 
 void QWinJumpListCategoryPrivate::addRecent(QWinJumpListItem *item)
 {
+    qDebug()<< __FUNCTION__<< '>';
     Q_ASSERT(item->type() == QWinJumpListItem::Link);
     wchar_t *id = 0;
     if (jumpList && !jumpList->identifier().isEmpty())
@@ -134,10 +142,12 @@ void QWinJumpListCategoryPrivate::addRecent(QWinJumpListItem *item)
         info.psl->Release();
     }
     delete[] id;
+    qDebug()<< __FUNCTION__<< '<';
 }
 
 void QWinJumpListCategoryPrivate::clearRecents()
 {
+    qDebug()<< __FUNCTION__<< '>';
     IApplicationDestinations *pDest = 0;
     HRESULT hresult = CoCreateInstance(qCLSID_ApplicationDestinations, 0, CLSCTX_INPROC_SERVER, qIID_IApplicationDestinations, reinterpret_cast<void **>(&pDest));
     if (SUCCEEDED(hresult)) {
@@ -152,6 +162,7 @@ void QWinJumpListCategoryPrivate::clearRecents()
     }
     if (FAILED(hresult))
         QWinJumpListPrivate::warning("clearRecents", hresult);
+    qDebug()<< __FUNCTION__<< '<';
 }
 
 /*!
@@ -160,6 +171,7 @@ void QWinJumpListCategoryPrivate::clearRecents()
 QWinJumpListCategory::QWinJumpListCategory(const QString &title) :
     d_ptr(new QWinJumpListCategoryPrivate)
 {
+    qDebug()<< __FUNCTION__<< title;
     d_ptr->title = title;
 }
 
@@ -256,6 +268,7 @@ QList<QWinJumpListItem *> QWinJumpListCategory::items() const
  */
 void QWinJumpListCategory::addItem(QWinJumpListItem *item)
 {
+    qDebug() << __FUNCTION__ <<  '>' << item;
     Q_D(QWinJumpListCategory);
     if (!item)
         return;
@@ -279,6 +292,7 @@ void QWinJumpListCategory::addItem(QWinJumpListItem *item)
             d->addRecent(item);
         d->invalidate();
     }
+    qDebug() << __FUNCTION__ << '<';
 }
 
 /*!
diff --git a/tests/manual/jumplist/jumplist.pro b/tests/manual/jumplist/jumplist.pro
index c8a061d..ace8364 100644
--- a/tests/manual/jumplist/jumplist.pro
+++ b/tests/manual/jumplist/jumplist.pro
@@ -1,5 +1,5 @@
 QT += widgets winextras
-
+CONFIG+=console
 TARGET = jumplist
 TEMPLATE = app
 
diff --git a/tests/manual/jumplist/testwidget.cpp b/tests/manual/jumplist/testwidget.cpp
index 15982a6..7c27f74 100644
--- a/tests/manual/jumplist/testwidget.cpp
+++ b/tests/manual/jumplist/testwidget.cpp
@@ -104,8 +104,10 @@ void TestWidget::setText(const QString &text)
 void TestWidget::updateJumpList()
 {
     QWinJumpList jumplist;
+
     if (!m_id.isEmpty())
         jumplist.setIdentifier(m_id);
+    qDebug() << __FUNCTION__<< &jumplist;
     const QString applicationBinary = QDir::toNativeSeparators(QCoreApplication::applicationFilePath());
     jumplist.recent()->setVisible(ui->cbShowRecent->isChecked());
     jumplist.frequent()->setVisible(ui->cbShowFrequent->isChecked());
@@ -113,6 +115,7 @@ void TestWidget::updateJumpList()
         QWinJumpListItem *item = new QWinJumpListItem(QWinJumpListItem::Link);
         item->setTitle(ui->cbRunFullscreen->text());
         item->setFilePath(applicationBinary);
+        item->setWorkingDirectory(QDir::currentPath());
         item->setArguments(QStringList("-fullscreen"));
         item->setIcon(style()->standardIcon(QStyle::SP_TitleBarMaxButton));
         jumplist.tasks()->addItem(item);
@@ -130,6 +133,7 @@ void TestWidget::updateJumpList()
                                   QStringList("-text"));
     }
     jumplist.tasks()->setVisible(!jumplist.tasks()->isEmpty());
+    qDebug() << __FUNCTION__<<  &jumplist;
 }
 
 void TestWidget::openFile()